# Docparse Upload Fetch
Fetch the latest version of an upload document from the docparse database. The upload should be an instance of **docparse-upload**.

[![Build Status](https://travis-ci.org/nisaacson/docparse-upload-fetch.png)](https://travis-ci.org/nisaacson/docparse-upload-fetch)
[![Dependency Status](https://david-dm.org/nisaacson/docparse-upload-fetch/status.png)](https://david-dm.org/nisaacson/docparse-upload-fetch)
Dependency tracking by [David](https://david-dm.org/)

# Usage

```javascript
var inspect = require('eyespect').inspector();
var fetch = require('docparse-upload-fetch');
var data = {
  hash: 'foo hash',
  updateURL: 'http://username1:password1@pdfer.local/api/fetch/12abcd43ef0c1dae7bcd90
  userID: 'fooID' // this should be the _id ObjectId of a docparse-user instance
}
fetch(data, function(err, reply) {
  if(err) {
    inspect(err, 'error fetching upload);
    return;
  }
  inspect(reply, 'fetched upload');
});
```

## Installation
`npm install docparse-upload-fetch`
