var async = require('async')
module.exports = function(data, callback) {
  var upload
  var output
  async.series([
    function (cb) {
      var check = data.check || require('./check')
      check(data, cb)
    },
    function (cb) {
      var findUpload = data.findUpload || require('./findUpload')
      findUpload(data, function (err, reply) {
        if (err) { return cb(err) }
        upload = reply
        cb()
      })
    },
    function(cb) {
      var userInUpload = data.userInUpload || require('./userInUpload')
      var inUploadData = {
        upload: upload,
        userID: data.userID
      }
      userInUpload(inUploadData, function (err, reply) {
        if (err) { return cb(err) }
        if (!reply) {
          return cb({
            message: 'error fetching upload',
            error: 'you are not permitted to fetch this upload',
            stack: new Error().stack
          })
        }
        cb()
      })
    },
    function(cb) {
      var fetchData = {
        upload: upload,
        url: data.updateURL,
        db: data.db
      }
      var fetchUpload = data.fetchUpload || require('./fetchUpload')
      fetchUpload(fetchData, function (err, reply) {
        if (err) { return cb(err) }
        upload = reply
        cb()
      })
    }
  ], function (err) {
    if (err) { return callback(err) }
    return callback(null, upload)
  })
}
