var inspect = require('eyespect').inspector();
var should = require('should');
var check = require('../check');
describe('Check if keys exist', function () {
  var data;
  beforeEach(function () {
    data = {
      userID: {},
      uploadID: 'fooUploadID',
      updateURL: 'http://google.com',
      db: {}
    };
  });
  it('should give error when userID is not set', function (done) {
    delete data.userID;
    check(data, function (err, reply) {
      should.exist(err);
      err.length.should.eql(1);
      var error = err[0];
      error.key.should.eql('userID');
      done();
    });
  });

  it('should give error when config is not set', function (done) {
    delete data.db;
    check(data, function (err, reply) {
      should.exist(err);
      err.length.should.eql(1);
      var error = err[0];
      error.key.should.eql('db');
      done();
    });
  });

  it('should give error when uploadID is not set', function (done) {
    delete data.uploadID
    check(data, function (err, reply) {
      should.exist(err);
      err.length.should.eql(1);
      var error = err[0];
      error.key.should.eql('uploadID');
      done();
    });
  });


  it('should give error when updateURL is not set', function (done) {
    delete data.updateURL;
    check(data, function (err, reply) {
      should.exist(err);
      err.length.should.eql(1);
      var error = err[0];
      error.key.should.eql('updateURL');
      done();
    });
  });

  it('should not give error for valid requests', function (done) {
    check(data, function (err) {
      should.not.exist(err);
      done();
    });
  });
});
