
var inspect = require('eyespect').inspector();
var should = require('should');
var fetchUpload = require('../fetchUpload');
describe('fetchUpload test', function () {
  var data;
  this.slow('1s');
  beforeEach(function () {
    data = {
      upload: {
        ocr_status: {
          complete: true
        }
      }
    };
  });

  it('should return upload directly if ocr_status.complete is true', function (done) {
    fetchUpload(data, function (err, reply) {
      should.not.exist(err);
      should.exist(reply);
      data.upload.should.eql(reply);
      done();
    });
  });

  it('should return upload when one is found', function (done) {
    data.upload.ocr_status.complete = false;
    var updatedUpload = {};
    var update =  function (data, cb) {
      cb(null, updatedUpload);
    };

    data.update = update;
    fetchUpload(data, function (err, reply) {
      should.not.exist(err);
      should.exist(reply);
      updatedUpload.should.eql(reply);
      done();
    });
  });
});