/**
 * Test that index.js is all wired up correctly
 */
var should = require('should');
var inspect = require('eyespect').inspector();

var fetch = require('../index');
describe('Test index.js is wired up correctly', function () {
  var upload = {};
    var dummy = function (data, cb) {
      cb(null, upload);
    };
  this.slow('1s');
  it('should process fetch request correctly', function (done) {
    var check = function (data, cb) {
      cb();
    };

    var userInUpload = function (data, cb) {
      cb(null, true);
    };

    var data = {
      check: check,
      findUpload: dummy,
      userInUpload: userInUpload,
      fetchUpload: dummy
    };

    fetch(data, function (err, reply) {
      should.not.exist(err);
      should.exist(reply);
      upload.should.eql(reply);
      done();
    });
  });


  it('should reject fetch requests where user is not in upload', function (done) {
    var check = function (data, cb) {
      cb();
    };
    var userInUpload = function (data, cb) {
      cb(null, false);
    };
    var data = {
      check: check,
      findUpload: dummy,
      userInUpload: userInUpload,
      fetchUpload: dummy
    };

    fetch(data, function (err, reply) {
      should.exist(err);
      should.not.exist(reply);
      err.should.eql('you are not permitted to fetch this upload');
      done();
    });
  });
});
