var rk = require('required-keys')

/**
 * Issue a fetch request the remote pdfer service for the latest information about this upload
 */
module.exports = function(data, cb) {
  var keys = ['url', 'upload', 'db']
  var err = rk.truthySync(data, keys)
  if (err) {
    return cb({
      message: 'error fetching upload, missing key',
      error: err,
      stack: new Error().stack
    })
  }
  var url = data.url
  var db = data.db
  var upload = data.upload
  var options = {
    url: url,
    method: 'get',
    json: true
  }
  var request = data.request || require('request')
  request(options, function (err, response, body) {
    if (err) { return cb(err) }
    var statusCode = response.statusCode
    if (statusCode !== 200) {
      return cb({
        message: 'error fetching upload',
        error: 'bad status code',
        url: url,
        stack: new Error().stack
      })
    }
    var id = upload._id
    var rev = upload._rev
    upload.status = body.status
    if (body.parsed) {
      upload.ocrStatus.complete = true
      upload.ocrStatus.running = true
      upload.textPages = body.textPages
      upload.numPages = body.textPages.length
      upload.status = 'ocr complete, waiting to parse'
    }

    db.save(id, rev, upload, function (err, reply) {
      if (err) {
        return cb({
          message: 'error fetching upload, failed to save updated upload back into db after fetching',
          error: err,
          url: url,
          stack: new Error().stack
        })
      }
      upload._rev = reply._rev
      return cb(null, upload)
    })
  })
}
